// Template application. Copyright  1996-1999 Santa Fe Institute.
// This library is distributed without any warranty; without even the
// implied warranty of merchantability or fitness for a particular purpose.
// See file LICENSE for details and terms of copying.

#import <defobj/Zone.h>
#import <simtools.h>
#import <objectbase/Swarm.h>

#import "Counter.h"
#import "ZoneAllocMapper.h"

// Sample model swarm - in this case, create one counter and schedule it.

@interface TemplateModelSwarm: Swarm
{

  id modelZone;

   id zoneObj;


  char* printMyHello;
  int scenario;
  int replicate;

  char* myString; 
  double* myDouble;
  double** myDouble2;

  BOOL stop;
  int stopCount;

  // MODIFY: add your own simulation parameters
  int increment;

  id modelActions;
  id modelSchedule;

  //char * someStrings[500];

  // MODIFY: add your own model objects.  
  Counter *counter;
}

// MODIFY: add access methods for what agents are visible.
- (Counter *)getCounter;

//+ createBegin: aZone;
+ create: aZone;
- createEnd;
- objectSetup;
- getModelZone;
- buildObjects;
- buildActions;
- activateIn: swarmContext;
- printMyHelloMessage;
- (BOOL) whenToStop;
- (void) drop;
@end
