// Template application. Copyright  1996-1999 Santa Fe Institute.
// This library is distributed without any warranty; without even the
// implied warranty of merchantability or fitness for a particular purpose.
// See file LICENSE for details and terms of copying.

#import <simtoolsgui/GUISwarm.h>
#import "TemplateModelSwarm.h"

// Sample graphical interface swarm for models.
@interface TemplateObserverSwarm: GUISwarm
{



@protected
 
  int modelNumber;

  int displayFrequency;

  id displayActions;
  id displaySchedule;

  id modelActivity;

  BOOL finished;

  // MODIFY: add display objects
  TemplateModelSwarm *templateModelSwarm;
  Counter *observedCounter;



}

+ createBegin: aZone;
- createEnd;
- objectSetup;
- buildObjects;
- buildActions;
- activateIn: swarmContext;
- getModelSwarm;
- setModelNumberTo: (int) aNum;
- (BOOL) areYouFinishedYet;
- checkToStop;
- (void) drop;
@end
