// Template application. Copyright  1996-1999 Santa Fe Institute.
// This library is distributed without any warranty; without even the
// implied warranty of merchantability or fitness for a particular purpose.
// See file LICENSE for details and terms of copying.

// Template main.m: this particular "simulation" just creates an object
// that spins its own counter, prints out numbers occasionally. Take that
// code out and add in your own simulation needs.
// Pay special attention to the word "MODIFY", that's for you to customize.
#import <objectbase.h>
#import <simtools.h>     // initSwarm () and swarmGUIMode
#import <simtoolsgui.h>  //
//#import "TemplateObserverSwarm.h"
#import "ExperSwarm.h"
#import "ExperBatchSwarm.h"

int
main (int argc, const char **argv)
{
  //TemplateObserverSwarm *observerSwarm;
  ExperSwarm *experimentSwarm;
  ExperBatchSwarm *batchSwarm;

  id <Zone> experZone=nil;

  initSwarm (argc, argv);

  //observerSwarm = [TemplateObserverSwarm create: globalZone];
  //[observerSwarm buildObjects];
  //[observerSwarm buildActions];
  //[observerSwarm activateIn: nil];
  //[observerSwarm go];


  experZone = [Zone create: globalZone];
  //xprint(globalZone);
  //xprint(experZone);

  if(swarmGUIMode == 1) {
      experimentSwarm = [ExperSwarm create: experZone];
      [experimentSwarm buildObjects];
      [experimentSwarm buildActions];
      [experimentSwarm activateIn: nil];
      [experimentSwarm go];
  }
  else {
      batchSwarm = [ExperBatchSwarm create: experZone];
      [batchSwarm buildObjects];
      [batchSwarm buildActions];
      [batchSwarm activateIn: nil];
      [batchSwarm go];
  }
/*
  fprintf(stderr, "<<MAIN>>\n");
  fflush(0);
  fprintf(stderr, "<<GLOBALZONE>>\n");
  fflush(0);

  xprint(globalZone);
  fprintf(stderr, "<<EXPERZONE>>\n");
  fflush(0);
  xprint(experZone);
  [experZone drop];
  experZone = nil;
  fprintf(stderr, "<<GLOBALZONE>>\n");
  fflush(0);
  xprint(globalZone);
  fprintf(stderr, "<<GLOBALZONE>>\n");
  fprintf(stderr, "<<MAIN>>\n");
  fflush(0);
*/
  return 0;
}
